<?php
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/api/client/client.class.php';
include_once $path.'/Model_adm.php';
include_once '/usr/local/esia/keystore/scripts/keystore.lib.php';
// $webp_name doit être identique au nom de la base de données !!!
//présent pour des raison de compatibilité
if(isset($_GET['id']) && !empty($_GET['id']))
{
    $_GET['nodeid'] = $_GET['id'];
}
$webp_name='WEBP_ENTERPRISE';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';

$error = "";
$arr_node_generic=array(
		"satellite" => array('url'=>'images/enterprise_', 'width' => '300px', 'height' => '350px', 'state_pic_left' => '240px', 'state_pic_top' => '275px'),
		"galaxy" => array('url'=>'images/enterprise_', 'width' => '300px', 'height' => '350px', 'state_pic_left' => '240px', 'state_pic_top' => '275px'),
		"infinity" => array('url'=>'images/enterprise_', 'width' => '300px', 'height' => '350px', 'state_pic_left' => '240px', 'state_pic_top' => '275px'),
);

$smarty->assign('node_generic',$arr_node_generic);
/* CREDENTIALS KEYSTORE GALAXY */
try
{
		$advconfigs = Model_adm::getAdvanceNodeConfig($dbconnection,$node->getId());
		$id = -1;
		foreach($advconfigs as $elem)
		{
			if($elem['name']=='API')
			{
				$id = $elem['id'];
			}
		}
		$cred_json = loadSettings($dbconnection,$id );
		$credentials = json_decode($cred_json,true);
}
catch(Exception $e)
{
	$error .= $e->getMessage().'<br />';
}

	/* Création API Client + authentification */
$unity_list=false;
try{
	$api = new ClientApi();
	$api->authentication($credentials['url'],$credentials['username'],$credentials['password'],$credentials['port']);

	$smarty->assign('node_access_url',$credentials['url'].':'.$credentials['port']);

	$ecatp_service = $api->get('system/service/ecatp-server');
    if( $ecatp_service['status'] != 'unavailable' )
    {
        $unity_list=true;
    }
}catch(Exception $e)
{
	$unity_list=false;
	$error .= $e->getMessage().' <br />';
}
$smarty->assign('show_unity_tab',$unity_list);
if(isset($_GET['action']) && !empty($_GET['action']))
{
	$action = $_GET['action'];
	$smarty->assign('action',$action);
}

$descr = htmlentities($node->getDescription() , ENT_QUOTES);
$smt_node = array('name'=>$node->getName(),
	'ip'=>$node->getIPv4Adress(),
	'id'=>$node->getId(),
	'description'=>$descr,
	'group'=>$node->getGroup()
);
$smarty->assign('node',$smt_node);

if(isset($action) && $action == 'alert')
{
	try{
		$ar = array();
		$alerts = $api->get("alert");
		//echo"<pre>";print_r($alerts);echo"</pre>";
		$smarty->assign('alerts',$alerts);
	}catch(Exception $e)
	{
		$error .= $e->getMessage().' <br />';
	}
}
elseif(isset($action) && $action == 'getGroups')
{
	try
	{
		$ar = array();
		$groups = $api->get("group_node");
		//echo"<pre>";print_r($groups);echo"</pre>";

		$pl_name = 'CHECK_API_GROUPNODE_STATE';

		$plugin = Model_esia::getPlugin($dbconnection,$pl_name);
		$plugin = $plugin[0];
	}
	catch(Exception $e)
	{
		$error .= $e->getMessage().' <br />';
	}
	//on ajoute un nouveau test.
	if($_GET['admin']=='addservice')
	{
		foreach ($groups as $group)
		{
			$i = $group['id'];
			if(isset($_POST[$i])&&is_numeric($_POST[$i]))
			{
				$param = preg_replace('#<groupid>#',$_POST[$i],$plugin['parameter']);
				$group_name = $_POST["$i-name"];
				//echo "addService : $pl_name."_".$group_name ,$plugin['id'],$node->getId(),300000,$param<br>";
				Model_adm::addService($dbconnection,$pl_name."_".$group_name ,$plugin['id'],$node->getId(),300000,$param,2,null,null,null,null,null);
			}
		}
		$redirection= $arr[0]['apache_path'].'/enterprise_control.php?id='.$node->getId();
		header('Location: '.$redirection);
		exit();
	}
	//on récupère les interfaces déjà testée
	$checked_group=array();
	$services = Model_esia::getServices($dbconnection,$node->getId());
	foreach($services as $service)
	{
		if(preg_match('#'.$pl_name.'#',$service['name']))
		{
			if(preg_match('#-i\s+([0-9]*)#',$service['parameter'],$regs))
			{
				$checked_group[] =$regs[1];
			}
		}
	}

	$group_table_smarty=array();
	foreach ($groups as $group)
	{
		$already=0;
		if(array_search($group['id'],$checked_group)!==false)
		{
			$already=1;
		}
		$group_table_smarty[]=array('id'=>$group['id'],'name'=>$group['parent_name'],'present'=>$already);
	}
	$smarty->assign('groups', $group_table_smarty);
}
else // action par défaut ou view
{
	//NAVBAR
	$navbar->addNode($node, $ICONS[$node->getType()]);

	//Etats des services
	$listState = Model_esia::countNodeState($dbconnection, $node->getId());
	$nbr_error=0;
	//on additionne les erreurs et les services OK (on a ainsi le total des services check et des services passifs)
	$nbr_error=$nbr_error+$listState['critical']+$listState['warning']+$listState['unknown'];
	$smt_status = array('nbr_error'=>$nbr_error,'nbr_service'=>$nbr_error + $listState['OK']);
	$smt_status = array_merge ($smt_status,$listState);

	/* RECUPERER LES SERVICES DU NOEUD */
	$services = Model_esia::getServices($dbconnection,$node->getId());
	$smarty->assign('nb_services',count($services));

	/* ETAT GENERAL DU NOEUD. (Au moins 1 critique ? Warning ? OK ?) */
	if(count($services)!=0)
	{
		if($listState['critical']> 0 )
			$general_node_state=2;
			elseif($listState['warning']> 0)
			$general_node_state=1;
			elseif($listState['unknown']> 0)
			$general_node_state=3;
			elseif($listState['OK']> 0)
			$general_node_state=0;
			elseif($listState['pending']> 0 || $listState['maintenance'])
			$general_node_state=5;
			else
				$general_node_state=0;
	}
	else
	{
		$general_node_state=-1; //AUCUN SERVICE
	}
	$smarty->assign('general_node_status',$general_node_state);

	/* INFO SUR LE NOEUD */
	//$smarty->assign('nodeName',$smt_node[name]);
	$smarty->assign('nodeType',strtolower($node->getType()));
	$smarty->assign('node_status',$smt_status);

	/* API CONNEXION */

	try
	{
		$ar = array();
		$ent_state_resume = $api->get("state");


		$smarty->assign('ent_state_resume',$ent_state_resume);
		$ar = array();
		$ent_state_node = $api->get("state/node");
		$smarty->assign('ent_state_node',$ent_state_node);
        if($user->getAccess($dbconnection,'mercury_licence'))
        {
            $smarty->assign('acces_mercury',1);
        }
		$license = $api->get('license');
		//print_r($license);
		if($license['status']=='ERROR')
		{
			if($license['message'] == 'Licence not found')
            {
				$mes = $lang['ERROR_LICENCE'];
				$reg = $lang['ERROR_LICENCE_HERE'];
				$mes =preg_replace('#\$HERE\$#',$reg,$mes);
				$smarty->assign('license_error',$mes);
			}
			else
            {
				$smarty->assign('license_error',$license['message']);
			}
		}
		else
		{
			$smarty->assign('galaxy_license',$license);
			$smarty->assign('expired_license',($license['expire'] < time()));
		}
		if(empty($ressources['SITE_LOCATION'])){
			$ressources['SITE_LOCATION'] = $node->getName();
		}

		$ressources = $api->get("service/localhost");
		$smarty->assign('ressources',$ressources);
	}
	catch(Exception $e)
	{
		$error .= $e->getMessage().' <br />';
	}
}
try
{
	$api->logout();
}
catch(Exception $e)
{
	$error .= $e->getMessage().' <br />';
}
$smarty->assign('errors',$error);
$smarty->display($template_path.'enterprise_control.html');
?>
